package com.zcloud.personnel.positioning.web;

import com.zcloud.personnel.positioning.api.SyncTaskServiceI;
import com.zcloud.personnel.positioning.dto.SyncTaskAddCmd;
import com.zcloud.personnel.positioning.dto.SyncTaskPageQry;
import com.zcloud.personnel.positioning.dto.SyncTaskUpdateCmd;
import com.zcloud.personnel.positioning.dto.clientobject.SyncTaskCO;
import com.alibaba.cola.dto.MultiResponse;
import com.alibaba.cola.dto.PageResponse;
import com.alibaba.cola.dto.Response;
import com.alibaba.cola.dto.SingleResponse;
import com.jjb.saas.framework.auth.model.SSOUser;
import com.jjb.saas.framework.auth.utils.AuthContext;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * web-adapter
 *
 * @Author fangjiakai
 * @Date 2026-07-07
 */
@Api(tags = "人员定位同步任务")
@RequestMapping("/${application.gateway}/syncTask")
@RestController
@AllArgsConstructor
public class SyncTaskController {
    private final SyncTaskServiceI syncTaskService;

    @ApiOperation("新增")
    @PostMapping("/save")
    public SingleResponse<SyncTaskCO> add(@Validated @RequestBody SyncTaskAddCmd cmd) {
        fillCorpinfo(cmd);
        return syncTaskService.add(cmd);
    }

    @ApiOperation("分页")
    @PostMapping("/list")
    public PageResponse<SyncTaskCO> page(@RequestBody SyncTaskPageQry qry) {
        return syncTaskService.listPage(qry);
    }

    @ApiOperation("所有数据")
    @GetMapping("/listAll")
    public MultiResponse<SyncTaskCO> listAll() {
        return MultiResponse.of(syncTaskService.listAll());
    }

    @ApiOperation("详情")
    @GetMapping("/{id}")
    public SingleResponse<SyncTaskCO> getInfoById(@PathVariable("id") Long id) {
        return SingleResponse.of(syncTaskService.queryById(id));
    }

    @ApiOperation("删除")
    @DeleteMapping("/{id}")
    public Response remove(@PathVariable("id") Long id) {
        syncTaskService.remove(id);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("删除多个")
    @DeleteMapping("/ids")
    public Response removeBatch(@RequestParam Long[] ids) {
        syncTaskService.removeBatch(ids);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("修改")
    @PutMapping("/edit")
    public SingleResponse edit(@Validated @RequestBody SyncTaskUpdateCmd cmd) {
        fillCorpinfo(cmd);
        syncTaskService.edit(cmd);
        return SingleResponse.buildSuccess();
    }

    private void fillCorpinfo(SyncTaskAddCmd cmd) {
        SSOUser ssoUser = AuthContext.getCurrentUser();
        if (ssoUser != null && ssoUser.getCompanyId() != null) {
            cmd.setCorpinfoId(String.valueOf(ssoUser.getCompanyId()));
        }
    }

    private void fillCorpinfo(SyncTaskUpdateCmd cmd) {
        SSOUser ssoUser = AuthContext.getCurrentUser();
        if (ssoUser != null && ssoUser.getCompanyId() != null) {
            cmd.setCorpinfoId(String.valueOf(ssoUser.getCompanyId()));
        }
    }
}
